=== debian/changelog ===
vtk-dicom (0.8.9-1) unstable; urgency=medium

  * Team upload.
  * Normalise Vcs-Browser
  * debhelper 12
  * Standards-Version: 4.3.0
  * cme fix dpkg-control
  * Drop ancient X-Python3-Version field
  * Drop unneeded get-orig-source target

 -- Andreas Tille <tille@debian.org>  Wed, 30 Jan 2019 16:37:14 +0100

vtk-dicom (0.8.8-1) unstable; urgency=medium

  * New upstream version 0.8.8
  * d/control: remove dependency on python << 3.7, Closes: #913452
  * d/control: Depend only on default python3-dev package, Closes: #912906
  * d/control,python3-vtk-dicom: use dh_exec for python install target path,
    Closes: #905419

 -- Gert Wollny <gewo@debian.org>  Sat, 01 Dec 2018 17:27:31 +0100

vtk-dicom (0.8.7-2) unstable; urgency=medium

  * d/control: Add break/replace lib package, Closes: #901214

 -- Gert Wollny <gewo@debian.org>  Sat, 10 Nov 2018 13:56:45 +0100

vtk-dicom (0.8.7-1) unstable; urgency=medium

  * d/*.install: move cmake files into -dev package, Closes: #901214
  * d/control: Update standards to 4.2.1, no changes
  * d/p: SQL lib patches
  * d/source/control: remove custom compression options
  * Upload to unstable

 -- Gert Wollny <gewo@debian.org>  Tue, 30 Oct 2018 16:46:09 +0100

vtk-dicom (0.8.7-1~exp1) experimental; urgency=medium

  [ Mathieu Malaterre ]
  * Remove self from Uploaders

  [ Gert Wollny ]
  * New upstream version 0.8.7
  * d/control: Prepare vor version 0.8 based on vtk7 
  * d/control, d/compat: update to dephelper 11
  * d/control: Update my uploader address
  * d/control: Update VCS url
  * d/* update packages for v0.8 and python3
  * d/p/03: run test with python3
  * d/rules: Update python version
  * d/copyright: Add copyright for some new files 

 -- Gert Wollny <gewo@debian.org>  Sat, 19 May 2018 11:47:10 +0200
