=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/vtk-dicom-$1\.tar\.gz/ \
  https://github.com/dgobbi/vtk-dicom/tags .*/v?(\d\S*)\.tar\.gz
